GLOBAL.NTR_WORTOX_MOD_LAN = true

local function IsChi()
    for name, data in pairs(GLOBAL.KnownModIndex.savedata.known_mods) do
        if data.enabled and data.modinfo then
            if data.modinfo.restart_required and (data.modinfo.name:upper():find('CHINESE') or data.modinfo.name:find('汉化')) then
                return true
            end
        end
    end
    return false
end
if GetModConfigData('language') == "AUTO" and IsChi() or GetModConfigData('language') == "CHI" then
    GLOBAL.NTR_WORTOX_MOD_LAN = false  --中文
else
    GLOBAL.NTR_WORTOX_MOD_LAN = true   --英语
end

GLOBAL.setmetatable(env,{__index=function(t,k) return GLOBAL.rawget(GLOBAL,k) end})
--[[
modimport "modmain/puella_fn.lua" 
modimport "modmain/strings.lua"
modimport "modmain/API.lua" 
modimport "modmain/actionsandstates.lua"
modimport "modmain/ui.lua"
modimport "modmain/geometry.lua"
modimport "modmain/help.lua"
modimport "modmain/bans.lua"

modimport "modmain/debugfunctions.lua"
--]]
local L = GLOBAL.NTR_WORTOX_MOD_LAN 

PrefabFiles = {
    'wortox_eat_soul_fx',
    'wortox_portal_fx',
    'wortox_soul_heal_fx',
    'wortox_soul_in_fx',
    'wortox_soul_spawn',
    'wortox_soul',
    'wortox',
}

Assets =
{

}

local charnames = {"wortox",}

local function Copy(table)
    local newtable = {}
    for k,v in pairs(table)do
        if type(v)~='table' then
            newtable[k] = v
        else
            newtable[k] = Copy(v)
        end
    end
    return newtable
end

for _,name in pairs(charnames) do
    table.insert(Assets,Asset( "ATLAS", "images/saveslot_portraits/"..name..".xml" ))
    table.insert(Assets,Asset( "ATLAS", "images/selectscreen_portraits/"..name..".xml" ))
    table.insert(Assets,Asset( "ATLAS", "bigportraits/"..name..".xml" ))
    table.insert(Assets,Asset( "ATLAS", "images/map_icons/"..name..".xml"))
    table.insert(CHARACTER_GENDERS.MALE, name)

    --local speech_wilson = L and require "speech_wilson" or require "speech_kyouko_ch"
    --STRINGS.CHARACTERS[string.upper(name)] = Copy(speech_wilson)
    STRINGS.CHARACTERS[name:upper()] = require "speech_wilson"
    
    AddMinimapAtlas("images/map_icons/"..name ..".xml")
    AddModCharacter(name)
end

local chardata = 
L and
{
    {
        prefab = "wortox",
        T = "The Soul Starved",
        N = "Wortox",
        D = "*Is an imp \n*Can hop through time and space \n*Less nourished by physical food",
        Q = "\"Pardon me if I don't shake your hand.\"",
    },
}

or
{
    {
        prefab = "wortox",
        T = "噬魂者",
        N = "沃拓克斯",
        D = "*是一位恶魔\n*可以跳跃时空\n*吃普通食物只获得一半收益",
        Q = "\"原谅我，我不喜欢握手.\"",
    },
}
if L then
    STRINGS.NAMES.WORTOX_SOUL = 'Soul'
    STRINGS.CHARACTERS.WORTOX.DESCRIBE.WORTOX_SOUL = 'Hyuyu! It looks tasty.'
else
    STRINGS.NAMES.WORTOX_SOUL = "灵魂"
    STRINGS.CHARACTERS.WORTOX.DESCRIBE.WORTOX_SOUL = "哼！看起来很好吃。"
end

local function SetCharData(data)
    STRINGS.CHARACTER_TITLES[data.prefab] = data.T
    STRINGS.CHARACTER_NAMES[data.prefab] = data.N
    STRINGS.CHARACTER_DESCRIPTIONS[data.prefab] = data.D
    STRINGS.CHARACTER_QUOTES[data.prefab] = data.Q
end

for _,data in pairs(chardata)do
    SetCharData(data)
end

--------------
local old_eat = ACTIONS.EAT.fn
ACTIONS.EAT.fn = function(act)
    local obj = act.target or act.invobject
    if old_eat(act)then
        return true
    end
    if act.doer.components.ntr_souleater and obj and obj.components.ntr_soul then
        return act.doer.components.ntr_souleater:EatSoul(obj) 
    end
end

local function EatPostInit(sg)
    old_eat_handler = sg.actionhandlers[ACTIONS.EAT].deststate
    sg.actionhandlers[ACTIONS.EAT].deststate = function(inst,action)
        if inst.sg:HasStateTag("busy") then
            return nil
        end
        local obj = action.target or action.invobject
        if inst.components.ntr_souleater and obj.components.ntr_soul then
            return "quickeat"
        end
        return old_eat_handler(inst,action)
    end
end

AddStategraphPostInit("wilson", EatPostInit)
AddStategraphPostInit("wilsonboating", EatPostInit)
---------------

local function CanBlinkToPoint(pt)
    local ground = GetWorld()
    if ground then
        local tile = ground.Map:GetTileAtPoint(pt.x, pt.y, pt.z)
        return tile ~= GROUND.IMPASSIBLE and tile < GROUND.UNDERGROUND
    end
end

local function CollectPointActions(doer, pos, actions, right)
    return CanBlinkToPoint(pos) and doer.components.inventory:Has("wortox_soul",1) and not doer.sg:HasStateTag('ntr_blink')
end

-----------
local function ActionPickerPostInit(c)
    local old_get = c.DoGetMouseActions
    function c:DoGetMouseActions(...)
        local left,right = old_get(self,...)
        if self.inst.prefab ~= "wortox" then
            return left,right
        end
        -------
        local ui = TheInput:GetHUDEntityUnderMouse()
        local pos = TheInput:GetWorldPosition()
        local isBoating = self.inst.components.driver:GetIsDriving()
        local isWater = self.inst:GetIsOnWater(pos.x, pos.y, pos.z)
        if not (isBoating == isWater) or not CollectPointActions(self.inst, pos) then 
            return left,right
        end
        if ui then
            return left,right
        end
        --if isBoating then return left,right end ---@---由于动画没有船通道,暂时禁止水上传送
        if not right then
            right = BufferedAction(self.inst, nil, ACTIONS.NTR_BLINK, nil, pos)
        else
            if right and right.action and right.action.priority < -1 then
                right = BufferedAction(self.inst, nil, ACTIONS.NTR_BLINK, nil, pos)
            end
        end
        return left,right
    end
end

AddComponentPostInit('playeractionpicker',ActionPickerPostInit)

local function ConPostInit(c)
    local old_can = c.CanTakeItemInSlot
    function c:CanTakeItemInSlot(item,...)
        local can = old_can(self,item,...)
        if item and item.prefab == 'wortox_soul' then
            return false
        else
            return can
        end
    end
end

AddComponentPostInit('container',ConPostInit)

-----------
local blink = Action({mount_enabled=true},10, false, true, 36)
blink.id = "NTR_BLINK"
blink.str = L and "Soul Hop" or "灵魂跳跃"
blink.fn = function(act)
    if act.doer and act.doer.sg and act.doer.sg.currentstate.name == "portal_jumpin_pre" and act.pos
        and act.doer.components.inventory 
        and act.doer.components.inventory:Has("wortox_soul", 1) then
        act.doer.components.inventory:ConsumeByName("wortox_soul", 1)
        act.doer.sg:GoToState("portal_jumpin", act.pos)
        return true
    end
end

AddAction(blink)
AddStategraphActionHandler("wilson", ActionHandler(blink,"portal_jumpin_pre"))
AddStategraphActionHandler("wilsonboating", ActionHandler(blink,"portal_jumpin_pre"))

------------
local function DoPortalTint(inst, val)
    if val > 0 then
        inst.components.colouradder:PushColour("portaltint", 154 / 255 * val, 23 / 255 * val, 19 / 255 * val, 0)
        val = 1 - val
        inst.AnimState:SetMultColour(val, val, val, 1)
    else
        inst.components.colouradder:PopColour("portaltint")
        inst.AnimState:SetMultColour(1, 1, 1, 1)
    end
end

local function ToggleOffPhysics(inst)
    inst.sg.statemem.isphysicstoggle = true
    inst.Physics:ClearCollisionMask()
    inst.Physics:CollidesWith(COLLISION.GROUND)
end

local function ToggleOnPhysics(inst)
    inst.sg.statemem.isphysicstoggle = nil
    inst.Physics:ClearCollisionMask()
    if IsDLCEnabled(PORKLAND_DLC) then
        inst.Physics:CollidesWith(GetWorldCollision())
        inst.Physics:CollidesWith(GetWaterCollision())
    else
        inst.Physics:CollidesWith(COLLISION.WORLD)
    end
    inst.Physics:CollidesWith(COLLISION.OBSTACLES)
    inst.Physics:CollidesWith(COLLISION.CHARACTERS)
    inst.Physics:CollidesWith(COLLISION.WAVES)
end

local function VehicleManager(inst,vel)
    if inst.components.driver:GetIsDriving() then
        if vel then
            inst.components.driver.vehicle:Show()
        else
            inst.components.driver.vehicle:Hide()
        end
    end
end


local newstates = 
{
    State{
        name = "portal_jumpin_pre",
        tags = { "busy","ntr_blink" },

        onenter = function(inst)
            inst.components.locomotor:Stop()
            inst.AnimState:PlayAnimation("wortox_portal_jumpin_pre")

            local buffaction = inst:GetBufferedAction()
            if buffaction ~= nil and buffaction.pos ~= nil then
                inst:ForceFacePoint(buffaction.pos:Get())
            end
            VehicleManager(inst,true)
        end,

        events =
        {
            EventHandler("animover", function(inst)
                if inst.AnimState:AnimDone() and not inst:PerformBufferedAction() then
                    inst.sg:GoToState("idle")
                end
            end),
        },
    },

    State{
        name = "portal_jumpin",
        tags = { "busy", "nodangle", "nomorph","ntr_blink" },

        onenter = function(inst, dest)
            inst.components.locomotor:Stop()
            inst.AnimState:PlayAnimation("wortox_portal_jumpin")
            local x, y, z = inst.Transform:GetWorldPosition()
            SpawnPrefab("wortox_portal_jumpin_fx").Transform:SetPosition(x, y, z)
            inst.sg:SetTimeout(11 * FRAMES)
            if dest ~= nil then
                inst.sg.statemem.dest = dest
                inst:ForceFacePoint(dest:Get())
            else
                inst.sg.statemem.dest = Vector3(x, y, z)
            end
            VehicleManager(inst,true)

        end,

        onupdate = function(inst)
            if inst.sg.statemem.tints ~= nil then
                DoPortalTint(inst, table.remove(inst.sg.statemem.tints))
                if #inst.sg.statemem.tints <= 0 then
                    inst.sg.statemem.tints = nil
                end
            end
        end,

        timeline =
        {
            TimeEvent(FRAMES, function(inst)
                inst.SoundEmitter:PlaySound("dontstarve/creatures/together/toad_stool/infection_post", nil, .7)
                inst.SoundEmitter:PlaySound("dontstarve/characters/wortox/soul/spawn", nil, .5)
            end),
            TimeEvent(2 * FRAMES, function(inst)
                inst.sg.statemem.tints = { 1, .6, .3, .1 }
                PlayFootstep(inst)
            end),
            TimeEvent(4 * FRAMES, function(inst)
                inst.sg:AddStateTag("noattack")
                inst.components.health:SetInvincible(true)
                inst.DynamicShadow:Enable(false)
            end),
        },

        ontimeout = function(inst)
            inst.sg.statemem.portaljumping = true
            inst.sg:GoToState("portal_jumpout", inst.sg.statemem.dest)
        end,

        onexit = function(inst)
            if not inst.sg.statemem.portaljumping then
                inst.components.health:SetInvincible(false)
                inst.DynamicShadow:Enable(true)
                DoPortalTint(inst, 0)
            end
        end,
    },

    State{
        name = "portal_jumpout",
        tags = { "busy", "ntr_blink", "nomorph", "noattack", "nointerrupt" },

        onenter = function(inst, dest)
            ToggleOffPhysics(inst)
            inst.components.locomotor:Stop()
            inst.AnimState:PlayAnimation("wortox_portal_jumpout")
            if dest ~= nil then
                inst.Physics:Teleport(dest:Get())
            else
                dest = inst:GetPosition()
            end
            SpawnPrefab("wortox_portal_jumpout_fx").Transform:SetPosition(dest:Get())
            inst.DynamicShadow:Enable(false)
            inst.sg:SetTimeout(14 * FRAMES)
            DoPortalTint(inst, 1)
            inst.components.health:SetInvincible(true)
            inst:PushEvent("soulhop")

            VehicleManager(inst,true)
        end,

        onupdate = function(inst)
            if inst.sg.statemem.tints ~= nil then
                DoPortalTint(inst, table.remove(inst.sg.statemem.tints))
                if #inst.sg.statemem.tints <= 0 then
                    inst.sg.statemem.tints = nil
                end
            end
        end,

        timeline =
        {
            TimeEvent(FRAMES, function(inst) inst.SoundEmitter:PlaySound("dontstarve/characters/wortox/soul/hop_out") end),
            TimeEvent(5 * FRAMES, function(inst)
                inst.sg.statemem.tints = { 0, .4, .7, .9 }
            end),
            TimeEvent(7 * FRAMES, function(inst)
                inst.components.health:SetInvincible(false)
                inst.sg:RemoveStateTag("noattack")
                inst.SoundEmitter:PlaySound("dontstarve/movement/bodyfall_dirt")
            end),
            TimeEvent(8 * FRAMES, function(inst)
                inst.DynamicShadow:Enable(true)
                ToggleOnPhysics(inst)
            end),
        },

        ontimeout = function(inst)
            inst.sg:GoToState("idle", true)
        end,

        onexit = function(inst)
            inst.components.health:SetInvincible(false)
            inst.DynamicShadow:Enable(true)
            DoPortalTint(inst, 0)
            inst:DoTaskInTime(0,function()VehicleManager(inst,false)end)
        end,
    },
}

for k,v in ipairs(newstates)do
    AddStategraphState("wilson", v)
    AddStategraphState("wilsonboating",v)  
end

local function newcomponents(inst)
    inst:AddComponent("colouradder")
end
AddPlayerPostInit(newcomponents)
