local assets =
{
    Asset("ANIM", "anim/wortox_portal.zip"),
}

local function MakeFX(name, anim)
    local function fn()
        local inst = CreateEntity()

        inst.entity:AddTransform()
        inst.entity:AddAnimState()

        inst.AnimState:SetBank("wilson")
        inst.AnimState:SetBuild("wortox_portal")
        inst.AnimState:PlayAnimation(anim)
        inst.AnimState:SetFinalOffset(-1)

        inst:ListenForEvent("animover", inst.Remove)
        inst.persists = false

        return inst
    end

    return Prefab(name, fn, assets)
end

return MakeFX("wortox_portal_jumpin_fx", "wortox_portal_jumpin"),
    MakeFX("wortox_portal_jumpout_fx", "wortox_portal_jumpout")
